﻿#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

int main(int argc, char* argv[])
{
    char** ptr = NULL;
    static int* passmark_flag = NULL; // パスワード生存フラグ
    FILE* fp, * fp2;
    static char str[256];
    static char dropFileName[2048];
    int length = 0, checkcount = 0, flag = 0;
    unsigned long ulFileLength = 0;
    unsigned long cursor = 0, i = 0;
    unsigned long ulAllCount = 0, ulSameCount = 0;

    if (argc == 1) {
        printf("書式:yokaidict.exe passwords.txt dict.txt\n");
        printf("エンターキーを入力すると終了します。\n");
        getchar();
        return 0;
    }

    // passwordsオープン
    if (fopen_s(&fp, argv[1], "rt") != 0) {
        printf("Password  File %s not found.\n", argv[1]);
        _fcloseall();
        return -1;
    }

    // dictオープン
    if (fopen_s(&fp2, argv[2], "rt") != 0) {
        printf("Password  File %s not found.\n", argv[2]);
        _fcloseall();
        return -1;
    }

    fseek(fp, 0, SEEK_END);
    ulFileLength = ftell(fp);
    fseek(fp, 0, SEEK_SET);

    ptr = (char**)malloc(ulFileLength + 1);
    if (ptr == NULL) {
        printf("fault.\n");
        free(ptr);
        _fcloseall();
        exit(1);
    }

    // テーブルファイルからキャラクタテーブルを分離して配列へ

    while (1) {
        ptr[cursor] = (char*)malloc(17);
        if (fgets(ptr[cursor], 16, fp) == NULL) break;
        cursor++;
    }
    // 終端に番兵セット
    ptr[cursor][0] = '*';
    ulAllCount = cursor; // 行数をセーブ
    fclose(fp);

    // 一致するものを探索する
    while (fgets(str, 16, fp2)) {
        printf("*%s", str); // 区切り文字を出力
        // 読み込みの後に改行を除去
        for (i = 0; i < 16; i++) {
            if (str[i] == '\n') {
                str[i] = '\0';
                break;
            }
        }
        // 全列挙
        for (i = 0; i < ulAllCount; i++) {
            if (ptr[i][0] == '*') break; // 念のため番兵で脱出
            // 単語を発見したら出力
            if (strstr(ptr[i],str)) {
                printf("%s", ptr[i]);
            }
        }
    }

    fclose(fp2);

    free(ptr);
    free(passmark_flag);
    return 0;
}