﻿// yokainumend.cpp : このファイルには 'main' 関数が含まれています。プログラム実行の開始と終了がそこで行われます。
//

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

// ひとつでもアルファベットと数字が隣接している行があったら除去するツール

int main(int argc, char* argv[])
{
    FILE* fp;
    static char str[256];
    int i = 0;
    int badflag = 0;
    int option = 0, flag = 0;


    if (argc == 1) {
        printf("usage:yokainumend.exe passwords.txt {num-start}\n");
        return 0;
    }

    if (argc == 2) {
        option = 0;
    }
    else {
        option = (int)strtol(argv[2], NULL, 10);
    }

    // passwordsオープン
    if (fopen_s(&fp, argv[1], "rt") != 0) {
        printf("Password  File %s not found.\n", argv[2]);
        _fcloseall();
        return -1;
    }

    // 行をロードしてシフトして出力
    while (fgets(str, 16, fp)) {
        badflag = 0;
        // 末尾の複数桁が数字とハイフンとドットの場合のみ出力
        for (i = option; i < 14; i++) {
            if (str[i] < '0' || str[i]>'9') {
                if (i == 13) { // 末尾記号は容赦なくバッドフラグ
                    badflag = 1;
                    break;
                }
                // ドットハイフン以外は容赦なくバッド
                if (str[i] != '-' && str[i] != '.') {
                    badflag = 1;
                    break;
                }
                // あったとしても数字が続かなければバッド
                if (str[i + 1] < '0' || str[i + 1]>'9') {
                    badflag = 1;
                    break;
                }
            }
        }
        if (!badflag) {
            printf("%s", str);
        }
    }

    _fcloseall();
    return 0;
}
