﻿#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

int main(int argc, char* argv[])
{
    char** ptr = NULL;
    static int* passmark_flag = NULL; // パスワード生存フラグ
    FILE* fp, * fp2;
    static char str[256];
    static char dropFileName[2048];
    int length = 0, checkcount = 0, flag = 0;
    unsigned long ulFileLength = 0;
    unsigned long cursor = 0, i = 0;
    unsigned long ulAllCount = 0, ulSameCount = 0;

    if (argc == 1) {
        printf("書式:yokaiundel.exe passwords1.txt チェック開始位置\n");
        printf("(※チェック開始位置は yokaiunder の指定値と同じ)\n");
        printf("エンターキーを入力すると終了します。\n");
        getchar();
        return 0;
    }

    // passwords1オープン
    if (fopen_s(&fp, argv[1], "rt") != 0) {
        printf("Password  File %s not found.\n", argv[1]);
        _fcloseall();
        return -1;
    }

    length = (int)strtol(argv[2], NULL, 10);

    fseek(fp, 0, SEEK_END);
    ulFileLength = ftell(fp);
    fseek(fp, 0, SEEK_SET);

    ptr = (char**)malloc(ulFileLength + 1);
    if (ptr == NULL) {
        printf("fault.\n");
        free(ptr);
        _fcloseall();
        exit(1);
    }

    // テーブルファイルからキャラクタテーブルを分離して配列へ

    while (1) {
        ptr[cursor] = (char*)malloc(17);
        if (fgets(ptr[cursor], 16, fp) == NULL) break;
        ptr[cursor][0x0E] = '\0'; // 改行除去
        cursor++;
    }
    // 終端に番兵セット
    ptr[cursor][0] = '*';
    ulAllCount = cursor; // 行数をセーブ
    fclose(fp);
    // 行数分のフラグを確保しメモリクリア
    passmark_flag = (int*)malloc(sizeof(int) * ulAllCount + 1);
    if (passmark_flag == NULL) {
        printf("fault.\n");
        free(ptr);
        free(passmark_flag);
        return -1;
    }
    memset(passmark_flag, 0, ulAllCount * sizeof(int));

    printf("Yokai-under-delete\n");
    printf("パスワード後ろ%d桁のハズレCSVファイルを用いるモードです。\n",14-length);
    printf("%ld 件のパスワードテーブルをロードしました。\n", ulAllCount);
    printf("ここにソート済みCSVファイルを投げ込むことで一致したパスワードを除去します。\n");

    while (1) {
        printf("画面に別のパスワードファイルをドロップしてエンターを押してください。\n");
        printf("そのままエンターキーを入力するとファイル保存に進みます。\n");
        gets_s(dropFileName);
        if (dropFileName[0] == '\0') {
            printf("保存ファイル名を拡張子付きで入力してください。\n>");
            gets_s(dropFileName);
            if (dropFileName[0] == '\0') {
                printf("保存せずに終了します。\n");
                break;
            }
            // passwords1オープン
            if (fopen_s(&fp2, dropFileName, "wb") != 0) {
                printf("ファイル作成に失敗しました。\n");
                fclose(fp2);
                break;
            }
            for (i = 0; i < ulAllCount; i++) {
                if (ptr[i][0] != 'd') { // デリートマークは無視
                    fputs(ptr[i], fp2);
                    putc(0x0A, fp2); // 改行コード追加挿入
                }
            }
            fclose(fp2);
            break;
        }

        if (fopen_s(&fp2, dropFileName, "rt") != 0) {
            printf("ファイル %s を開けません。\n", dropFileName);
            fclose(fp2);
            continue;
        }

        // 一致するものを探索する
        while (fgets(str, 16, fp2)) {
            // CSVのカンマを\0に差し替える
            for (i = 0; i < 16; i++) {
                if (str[i] == ',') {
                    str[i] = '\0';
                    break;
                }
            }
            // 一致チェック
            for (i = 0; i < ulAllCount; i++) {
                if (ptr[i][0] == '*') break; // 念のため番兵で脱出
                if (ptr[i][0] == 'd') continue; // 削除済みは容赦なくスキップ
                // 合致するパスワードを発見。
                if (strcmp(str, ptr[i]+length) == 0) {
                    passmark_flag[i] = 1;
                }
            }
        }
        // 一致したパターンに削除マークを付ける
        ulSameCount = 0;
        for (i = 0; i < ulAllCount; i++) {
            if (passmark_flag[i] == 1) {
                ptr[i][0] = 'd';
                ptr[i][1] = '\0';
                ulSameCount++;
            }
        }
        // 再びフラグクリア
        memset(passmark_flag, 0, ulAllCount * sizeof(int));

        fclose(fp2);
        printf("マスタとなるテーブルから%ld件のパスワードを除去しました。\n", ulSameCount);
    }
    free(ptr);
    free(passmark_flag);
    printf("End.\n");
    return 0;
}